var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var XmlElementNames_1 = require("../Core/XmlElementNames");
var Strings_1 = require("../Strings");
var XmlNamespace_1 = require("../Enumerations/XmlNamespace");
var ComplexProperty_1 = require("./ComplexProperty");
var StringList = (function (_super) {
    __extends(StringList, _super);
    function StringList(stringOrItemXmlElementName) {
        _super.call(this);
        this.items = []; // /*System.Collections.Generic.List<string>*/;
        this.itemXmlElementName = XmlElementNames_1.XmlElementNames.String;
        if (typeof stringOrItemXmlElementName !== 'undefined') {
            if (typeof stringOrItemXmlElementName === 'string') {
                this.itemXmlElementName = stringOrItemXmlElementName;
            }
            else {
                this.AddRange(stringOrItemXmlElementName);
            }
        }
    }
    Object.defineProperty(StringList.prototype, "Count", {
        get: function () { return this.items.length; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StringList.prototype, "Items", {
        get: function () { return this.items; },
        enumerable: true,
        configurable: true
    });
    StringList.prototype._getItem = function (index) {
        if (index < 0 || index >= this.Count) {
            throw new Error("index - " + Strings_1.Strings.IndexIsOutOfRange); //ArgumentOutOfRangeException
        }
        return this.items[index];
    };
    StringList.prototype._setItem = function (index, value) {
        if (index < 0 || index >= this.Count) {
            throw new Error("index - " + Strings_1.Strings.IndexIsOutOfRange); //ArgumentOutOfRangeException
        }
        if (this.items[index] !== value) {
            this.items[index] = value;
            this.Changed();
        }
    };
    StringList.prototype.Add = function (s) {
        this.items.push(s);
        this.Changed();
    };
    StringList.prototype.AddRange = function (strings /*System.Collections.Generic.IEnumerable<string>*/) {
        var changed = false;
        for (var _i = 0; _i < strings.length; _i++) {
            var s = strings[_i];
            if (!this.Contains(s)) {
                this.items.push(s);
                changed = true;
            }
        }
        if (changed) {
            this.Changed();
        }
    };
    StringList.prototype.Clear = function () {
        this.items.splice(0);
        this.Changed();
    };
    StringList.prototype.Contains = function (s) { return this.items.indexOf(s) >= 0; };
    StringList.prototype.Equals = function (obj) { throw new Error("StringList.ts - Equals : Not implemented."); };
    StringList.prototype.GetEnumerator = function () { throw new Error("StringList.ts - GetEnumerator : Not implemented."); };
    StringList.prototype.GetHashCode = function () { throw new Error("StringList.ts - GetHashCode : Not implemented."); };
    StringList.prototype.InternalToJson = function (service) { throw new Error("StringList.ts - InternalToJson : Not implemented."); };
    StringList.prototype.Remove = function (s) {
        var index = this.items.indexOf(s);
        if (index >= 0) {
            this.RemoveAt(index);
            this.Changed();
            return true;
        }
        return false;
    };
    StringList.prototype.RemoveAt = function (index) {
        if (index < 0 || index >= this.Count) {
            throw new Error("index - " + Strings_1.Strings.IndexIsOutOfRange); //ArgumentOutOfRangeException
        }
        this.items.splice(index, 1);
        this.Changed();
    };
    StringList.prototype.ToString = function () { return this.items.join(","); };
    StringList.prototype.ReadElementsFromXmlJsObject = function (reader) { debugger; throw new Error("StringList.ts - TryReadElementFromXmlJsObject : Not implemented."); return null; };
    StringList.prototype.WriteElementsToXml = function (writer) {
        for (var _i = 0, _a = this.items; _i < _a.length; _i++) {
            var item = _a[_i];
            writer.WriteStartElement(XmlNamespace_1.XmlNamespace.Types, this.itemXmlElementName);
            writer.WriteValue(item, this.itemXmlElementName);
            writer.WriteEndElement();
        }
    };
    return StringList;
})(ComplexProperty_1.ComplexProperty);
exports.StringList = StringList;
//}
