var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var XmlElementNames_1 = require("../../XmlElementNames");
var ServiceErrorHandling_1 = require("../../../Enumerations/ServiceErrorHandling");
var Strings_1 = require("../../../Strings");
var ServiceVersionException_1 = require("../../../Exceptions/ServiceVersionException");
var ItemAttachment_1 = require("../../../ComplexProperties/ItemAttachment");
var FolderId_1 = require("../../../ComplexProperties/FolderId");
var EwsLogging_1 = require("../../EwsLogging");
var PropertySet_1 = require("../../PropertySet");
var ExchangeVersion_1 = require("../../../Enumerations/ExchangeVersion");
var ServiceObjectSchema_1 = require("../Schemas/ServiceObjectSchema");
var ItemSchema_1 = require("../Schemas/ItemSchema");
var ExtensionMethods_1 = require("../../../ExtensionMethods");
var ServiceObject_1 = require("../ServiceObject");
var Item = (function (_super) {
    __extends(Item, _super);
    function Item(obj) {
        //constructor(obj: any) {
        //super(obj instanceof ExchangeService ? obj : (obj instanceof ItemAttachment ? obj.Service : null));
        _super.call(this, obj instanceof ItemAttachment_1.ItemAttachment ? obj.Service : obj); //todo:fix -can not user instanceof with exchangeservice, creates circular loop with ewsutility 
        //    constructor(obj: any) { super(obj); }
        this.parentAttachment = null;
        if (obj instanceof ItemAttachment_1.ItemAttachment) {
            var parentAttachment = obj;
            EwsLogging_1.EwsLogging.Assert(parentAttachment != null, "Item.ctor", "parentAttachment is null");
            this.parentAttachment = parentAttachment;
        }
    }
    Object.defineProperty(Item.prototype, "ParentAttachment", {
        get: function () {
            return this.parentAttachment;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "RootItemId", {
        get: function () {
            if (this.IsAttachment && this.ParentAttachment.Owner !== null) {
                return this.ParentAttachment.Owner.RootItemId;
            }
            return this.Id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsAttachment", {
        get: function () { return this.parentAttachment != null && typeof this.parentAttachment !== 'undefined'; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsNew", {
        get: function () {
            // Item attachments don't have an Id, need to check whether the
            // parentAttachment is new or not.
            if (this.IsAttachment) {
                return this.ParentAttachment.IsNew;
            }
            else {
                return _super.prototype.IsNewProxy.call(this);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Id", {
        get: function () { return this.PropertyBag._getItem(this.GetIdPropertyDefinition()); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "MimeContent", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.MimeContent);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.MimeContent, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ParentFolderId", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ParentFolderId);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Sensitivity", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Sensitivity);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Sensitivity, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Attachments", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Attachments);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DateTimeReceived", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.DateTimeReceived);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Size", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Size);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Categories", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Categories);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Categories, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Culture", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Culture);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Culture, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Importance", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Importance);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Importance, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "InReplyTo", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.InReplyTo);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.InReplyTo, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsSubmitted", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsSubmitted);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsAssociated", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsAssociated);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsDraft", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsDraft);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsFromMe", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsFromMe);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsResend", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsResend);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsUnmodified", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsUnmodified);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "InternetMessageHeaders", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.InternetMessageHeaders);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DateTimeSent", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.DateTimeSent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DateTimeCreated", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.DateTimeCreated);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "AllowedResponseActions", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.AllowedResponseActions);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ReminderDueBy", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ReminderDueBy);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.ReminderDueBy, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IsReminderSet", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IsReminderSet);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.IsReminderSet, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ReminderMinutesBeforeStart", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ReminderMinutesBeforeStart);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.ReminderMinutesBeforeStart, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DisplayCc", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.DisplayCc);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DisplayTo", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.DisplayTo);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "HasAttachments", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.HasAttachments);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Body", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Body);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Body, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ItemClass", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ItemClass);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.ItemClass, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Subject", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Subject);
        },
        set: function (value) {
            this.SetSubject(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "WebClientReadFormQueryString", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.WebClientReadFormQueryString);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "WebClientEditFormQueryString", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.WebClientEditFormQueryString);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ExtendedProperties", {
        get: function () {
            return this.PropertyBag._getItem(ServiceObjectSchema_1.ServiceObjectSchema.ExtendedProperties);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "EffectiveRights", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.EffectiveRights);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "LastModifiedName", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.LastModifiedName);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "LastModifiedTime", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.LastModifiedTime);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ConversationId", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ConversationId);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "UniqueBody", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.UniqueBody);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "StoreEntryId", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.StoreEntryId);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "InstanceKey", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.InstanceKey);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Flag", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Flag);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.Flag, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "NormalizedBody", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.NormalizedBody);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "EntityExtractionResult", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.EntityExtractionResult);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "PolicyTag", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.PolicyTag);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.PolicyTag, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "ArchiveTag", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.ArchiveTag);
        },
        set: function (value) {
            this.PropertyBag._setItem(ItemSchema_1.ItemSchema.ArchiveTag, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "RetentionDate", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.RetentionDate);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "Preview", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.Preview);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "TextBody", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.TextBody);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "IconIndex", {
        get: function () {
            return this.PropertyBag._getItem(ItemSchema_1.ItemSchema.IconIndex);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DefaultAffectedTaskOccurrences", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DefaultSendCancellationsMode", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DefaultSendInvitationsMode", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Item.prototype, "DefaultSendInvitationsOrCancellationsMode", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    //Bind(service: ExchangeService, id: ItemId): Item { throw new Error("Item.ts - Bind : Not implemented."); }
    Item.prototype.Bind = function (service, id, propertySet) {
        if (propertySet === void 0) { propertySet = PropertySet_1.PropertySet.FirstClassProperties; }
        return service.BindToItem(id, propertySet);
    };
    // Copy(destinationFolderName: WellKnownFolderName): Item { throw new Error("Item.ts - Copy : Not implemented."); }
    // Copy(destinationFolderId: FolderId): Item { throw new Error("Item.ts - Copy : Not implemented."); }
    Item.prototype.Copy = function (destinationFolderIdOrName) {
        this.ThrowIfThisIsNew();
        this.ThrowIfThisIsAttachment();
        var folderId = null;
        if (destinationFolderIdOrName instanceof FolderId_1.FolderId) {
            folderId = destinationFolderIdOrName;
        }
        else {
            folderId = new FolderId_1.FolderId(destinationFolderIdOrName);
        }
        //EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
        return this.Service.CopyItem(this.Id, folderId);
    };
    //Delete(deleteMode: DeleteMode): void { throw new Error("Item.ts - Delete : Not implemented."); }
    //Delete(deleteMode: DeleteMode, suppressReadReceipts: boolean): any { throw new Error("Item.ts - Delete : Not implemented."); }
    Item.prototype.Delete = function (deleteMode, suppressReadReceipts) {
        if (suppressReadReceipts === void 0) { suppressReadReceipts = false; }
        this.InternalDelete(deleteMode, null, null, suppressReadReceipts);
    };
    Item.prototype.GetExtendedProperties = function () { return this.ExtendedProperties; };
    Item.prototype.GetIdPropertyDefinition = function () { return ItemSchema_1.ItemSchema.Id; };
    Item.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
        // Starting E14SP2, attachment will be sent along with CreateItem requests. 
        // if the attachment used to require the Timezone header, CreateItem request should do so too.
        //
        debugger; //filtering of specific type needed.
        if (!isUpdateOperation &&
            (this.Service.RequestedServerVersion >= ExchangeVersion_1.ExchangeVersion.Exchange2010_SP2)) {
            for (var _i = 0, _a = this.Attachments.Items; _i < _a.length; _i++) {
                var itemAttachment = _a[_i];
                ;
            } //.OfType<ItemAttachment>())
            {
                if ((itemAttachment.Item != null) && itemAttachment.Item.GetIsTimeZoneHeaderRequired(false /* isUpdateOperation */)) {
                    return true;
                }
            }
        }
        return _super.prototype.GetIsTimeZoneHeaderRequired.call(this, isUpdateOperation);
    };
    Item.prototype.GetMinimumRequiredServerVersion = function () { return ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1; };
    Item.prototype.GetSchema = function () { return ItemSchema_1.ItemSchema.Instance; };
    Item.prototype.GetXmlElementName = function () { return XmlElementNames_1.XmlElementNames.Item; };
    Item.prototype.HasUnprocessedAttachmentChanges = function () { return this.Attachments.HasUnprocessedChanges(); };
    Item.prototype.InternalCreate = function (parentFolderId, messageDisposition, sendInvitationsMode) {
        this.ThrowIfThisIsNotNew();
        this.ThrowIfThisIsAttachment();
        if (this.IsNew || this.IsDirty) {
            this.Service.CreateItem(this, parentFolderId, messageDisposition, sendInvitationsMode !== null ? sendInvitationsMode : this.DefaultSendInvitationsMode);
            this.Attachments.Save();
        }
    };
    //InternalDelete(deleteMode: DeleteMode, sendCancellationsMode: SendCancellationsMode, affectedTaskOccurrences: AffectedTaskOccurrence, suppressReadReceipts: boolean): any { throw new Error("Item.ts - InternalDelete : Not implemented."); }
    //InternalDelete(deleteMode: DeleteMode, sendCancellationsMode: SendCancellationsMode, affectedTaskOccurrences: AffectedTaskOccurrence): any;//{ throw new Error("Item.ts - InternalDelete : Not implemented.");}
    Item.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts) {
        if (sendCancellationsMode === void 0) { sendCancellationsMode = this.DefaultSendCancellationsMode; }
        if (affectedTaskOccurrences === void 0) { affectedTaskOccurrences = this.DefaultAffectedTaskOccurrences; }
        if (suppressReadReceipts === void 0) { suppressReadReceipts = false; }
        this.ThrowIfThisIsNew();
        this.ThrowIfThisIsAttachment();
        // If sendCancellationsMode is null, use the default value that's appropriate for item type.
        // if (!sendCancellationsMode)
        // {
        //     sendCancellationsMode = this.DefaultSendCancellationsMode;
        // }
        // If affectedTaskOccurrences is null, use the default value that's appropriate for item type.
        // if (!affectedTaskOccurrences)
        // {
        //     affectedTaskOccurrences = this.DefaultAffectedTaskOccurrences;
        // }
        this.Service.DeleteItem(this.Id, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts);
    };
    Item.prototype.InternalLoad = function (propertySet) {
        this.ThrowIfThisIsNew();
        this.ThrowIfThisIsAttachment();
        this.Service.InternalLoadPropertiesForItems([this], propertySet, ServiceErrorHandling_1.ServiceErrorHandling.ThrowOnError);
    };
    //InternalUpdate(parentFolderId: FolderId, conflictResolutionMode: ConflictResolutionMode, messageDisposition: MessageDisposition, sendInvitationsOrCancellationsMode: SendInvitationsOrCancellationsMode): Item { throw new Error("Item.ts - InternalUpdate : Not implemented."); }
    //InternalUpdate(parentFolderId: FolderId, conflictResolutionMode: ConflictResolutionMode, messageDisposition: MessageDisposition, sendInvitationsOrCancellationsMode: SendInvitationsOrCancellationsMode, suppressReadReceipts: boolean): Item { throw new Error("Item.ts - InternalUpdate : Not implemented."); }
    Item.prototype.InternalUpdate = function (parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
        if (suppressReadReceipts === void 0) { suppressReadReceipts = false; }
        this.ThrowIfThisIsNew();
        this.ThrowIfThisIsAttachment();
        var returnedItem = null;
        if (this.IsDirty && this.PropertyBag.GetIsUpdateCallNecessary()) {
            returnedItem = this.Service.UpdateItem(this, parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode !== null ? sendInvitationsOrCancellationsMode : this.DefaultSendInvitationsOrCancellationsMode, suppressReadReceipts);
        }
        // Regardless of whether item is dirty or not, if it has unprocessed
        // attachment changes, validate them and process now.
        if (this.HasUnprocessedAttachmentChanges()) {
            this.Attachments.Validate();
            this.Attachments.Save();
        }
        return returnedItem;
    };
    //Move(destinationFolderId: FolderId): Item { throw new Error("Item.ts - Move : Not implemented."); }
    //Move(destinationFolderName: WellKnownFolderName): Item { throw new Error("Item.ts - Move : Not implemented."); }
    Item.prototype.Move = function (destinationFolderIdOrName) {
        this.ThrowIfThisIsNew();
        this.ThrowIfThisIsAttachment();
        var folderId = null;
        if (destinationFolderIdOrName instanceof FolderId_1.FolderId) {
            folderId = destinationFolderIdOrName;
        }
        else {
            folderId = new FolderId_1.FolderId(destinationFolderIdOrName);
        }
        //EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
        return this.Service.MoveItem(this.Id, destinationFolderIdOrName);
    };
    Item.prototype.RemoveExtendedProperty = function (extendedPropertyDefinition) { return this.ExtendedProperties.RemoveExtendedProperty(extendedPropertyDefinition); };
    Item.prototype.Save = function (parentFolderId) { throw new Error("Item.ts - Save : Not implemented."); };
    //Save(parentFolderName: WellKnownFolderName): any { throw new Error("Item.ts - Save : Not implemented."); }
    //Save(): any { throw new Error("Item.ts - Save : Not implemented."); }
    Item.prototype.SetExtendedProperty = function (extendedPropertyDefinition, value) { throw new Error("Item.ts - SetExtendedProperty : Not implemented."); };
    Item.prototype.SetSubject = function (subject) { throw new Error("Item.ts - SetSubject : Not implemented."); };
    Item.prototype.ThrowIfThisIsAttachment = function () {
        if (this.IsAttachment) {
            throw new Error(Strings_1.Strings.OperationDoesNotSupportAttachments); //InvalidOperationException
        }
    };
    Item.prototype.Update = function (conflictResolutionMode, suppressReadReceipts) { throw new Error("Item.ts - Update : Not implemented."); };
    //Update(conflictResolutionMode: ConflictResolutionMode): any { throw new Error("Item.ts - Update : Not implemented."); }
    Item.prototype.Validate = function () {
        _super.prototype.Validate.call(this);
        this.Attachments.Validate();
        // Flag parameter is only valid for Exchange2013 or higher
        //
        var flag = { outValue: null };
        if (this.TryGetProperty(ItemSchema_1.ItemSchema.Flag, flag) && flag.outValue != null) {
            if (this.Service.RequestedServerVersion < ExchangeVersion_1.ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException_1.ServiceVersionException(ExtensionMethods_1.StringHelper.Format(Strings_1.Strings.ParameterIncompatibleWithRequestVersion, "Flag", ExchangeVersion_1.ExchangeVersion.Exchange2013));
            }
            flag.outValue.Validate();
        }
    };
    //created this to keep item and folder object away frmo here. modularization would fail and create a larger file
    Item.prototype.IsItemInstance = function () { return true; }; //only item instance would return true.
    return Item;
})(ServiceObject_1.ServiceObject);
exports.Item = Item;
