var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var XmlElementNames_1 = require("../../XmlElementNames");
var ComplexPropertyDefinition_1 = require("../../../PropertyDefinitions/ComplexPropertyDefinition");
var PropertyDefinitionFlags_1 = require("../../../Enumerations/PropertyDefinitionFlags");
var ExchangeVersion_1 = require("../../../Enumerations/ExchangeVersion");
var ConversationId_1 = require("../../../ComplexProperties/ConversationId");
var StringPropertyDefinition_1 = require("../../../PropertyDefinitions/StringPropertyDefinition");
var StringList_1 = require("../../../ComplexProperties/StringList");
var DateTimePropertyDefinition_1 = require("../../../PropertyDefinitions/DateTimePropertyDefinition");
var GenericPropertyDefinition_1 = require("../../../PropertyDefinitions/GenericPropertyDefinition");
var BoolPropertyDefinition_1 = require("../../../PropertyDefinitions/BoolPropertyDefinition");
var IntPropertyDefinition_1 = require("../../../PropertyDefinitions/IntPropertyDefinition");
var ItemIdCollection_1 = require("../../../ComplexProperties/ItemIdCollection");
var ByteArrayPropertyDefinition_1 = require("../../../PropertyDefinitions/ByteArrayPropertyDefinition");
var ServiceObjectSchema_1 = require("./ServiceObjectSchema");
//module ConversationSchema {
var FieldUris;
(function (FieldUris) {
    FieldUris.ConversationId = "conversation:ConversationId";
    FieldUris.ConversationTopic = "conversation:ConversationTopic";
    FieldUris.UniqueRecipients = "conversation:UniqueRecipients";
    FieldUris.GlobalUniqueRecipients = "conversation:GlobalUniqueRecipients";
    FieldUris.UniqueUnreadSenders = "conversation:UniqueUnreadSenders";
    FieldUris.GlobalUniqueUnreadSenders = "conversation:GlobalUniqueUnreadSenders";
    FieldUris.UniqueSenders = "conversation:UniqueSenders";
    FieldUris.GlobalUniqueSenders = "conversation:GlobalUniqueSenders";
    FieldUris.LastDeliveryTime = "conversation:LastDeliveryTime";
    FieldUris.GlobalLastDeliveryTime = "conversation:GlobalLastDeliveryTime";
    FieldUris.Categories = "conversation:Categories";
    FieldUris.GlobalCategories = "conversation:GlobalCategories";
    FieldUris.FlagStatus = "conversation:FlagStatus";
    FieldUris.GlobalFlagStatus = "conversation:GlobalFlagStatus";
    FieldUris.HasAttachments = "conversation:HasAttachments";
    FieldUris.GlobalHasAttachments = "conversation:GlobalHasAttachments";
    FieldUris.MessageCount = "conversation:MessageCount";
    FieldUris.GlobalMessageCount = "conversation:GlobalMessageCount";
    FieldUris.UnreadCount = "conversation:UnreadCount";
    FieldUris.GlobalUnreadCount = "conversation:GlobalUnreadCount";
    FieldUris.Size = "conversation:Size";
    FieldUris.GlobalSize = "conversation:GlobalSize";
    FieldUris.ItemClasses = "conversation:ItemClasses";
    FieldUris.GlobalItemClasses = "conversation:GlobalItemClasses";
    FieldUris.Importance = "conversation:Importance";
    FieldUris.GlobalImportance = "conversation:GlobalImportance";
    FieldUris.ItemIds = "conversation:ItemIds";
    FieldUris.GlobalItemIds = "conversation:GlobalItemIds";
    FieldUris.LastModifiedTime = "conversation:LastModifiedTime";
    FieldUris.InstanceKey = "conversation:InstanceKey";
    FieldUris.Preview = "conversation:Preview";
    FieldUris.IconIndex = "conversation:IconIndex";
    FieldUris.GlobalIconIndex = "conversation:GlobalIconIndex";
    FieldUris.DraftItemIds = "conversation:DraftItemIds";
    FieldUris.HasIrm = "conversation:HasIrm";
    FieldUris.GlobalHasIrm = "conversation:GlobalHasIrm";
})(FieldUris || (FieldUris = {}));
//}
var ConversationSchema = (function (_super) {
    __extends(ConversationSchema, _super);
    function ConversationSchema() {
        _super.apply(this, arguments);
    }
    ConversationSchema.prototype.RegisterProperties = function () {
        _super.prototype.RegisterProperties.call(this);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Id);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Topic);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueRecipients);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueRecipients);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueUnreadSenders);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueUnreadSenders);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueSenders);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueSenders);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.LastDeliveryTime);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalLastDeliveryTime);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Categories);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalCategories);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.FlagStatus);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalFlagStatus);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.HasAttachments);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalHasAttachments);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.MessageCount);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalMessageCount);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.UnreadCount);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUnreadCount);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Size);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalSize);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.ItemClasses);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalItemClasses);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Importance);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalImportance);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.ItemIds);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalItemIds);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.LastModifiedTime);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.InstanceKey);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.Preview);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.IconIndex);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalIconIndex);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.DraftItemIds);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.HasIrm);
        _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalHasIrm);
    };
    ConversationSchema.Id = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ConversationId", XmlElementNames_1.XmlElementNames.ConversationId, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.ConversationId, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ConversationId_1.ConversationId(); });
    ConversationSchema.Topic = new StringPropertyDefinition_1.StringPropertyDefinition("ConversationTopic", XmlElementNames_1.XmlElementNames.ConversationTopic, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.ConversationTopic, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.UniqueRecipients = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("UniqueRecipients", XmlElementNames_1.XmlElementNames.UniqueRecipients, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.UniqueRecipients, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.GlobalUniqueRecipients = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalUniqueRecipients", XmlElementNames_1.XmlElementNames.GlobalUniqueRecipients, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalUniqueRecipients, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.UniqueUnreadSenders = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("UniqueUnreadSenders", XmlElementNames_1.XmlElementNames.UniqueUnreadSenders, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.UniqueUnreadSenders, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.GlobalUniqueUnreadSenders = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalUniqueUnreadSenders", XmlElementNames_1.XmlElementNames.GlobalUniqueUnreadSenders, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalUniqueUnreadSenders, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.UniqueSenders = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("UniqueSenders", XmlElementNames_1.XmlElementNames.UniqueSenders, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.UniqueSenders, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.GlobalUniqueSenders = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalUniqueSenders", XmlElementNames_1.XmlElementNames.GlobalUniqueSenders, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalUniqueSenders, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.LastDeliveryTime = new DateTimePropertyDefinition_1.DateTimePropertyDefinition("LastDeliveryTime", XmlElementNames_1.XmlElementNames.LastDeliveryTime, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.LastDeliveryTime, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalLastDeliveryTime = new DateTimePropertyDefinition_1.DateTimePropertyDefinition("GlobalLastDeliveryTime", XmlElementNames_1.XmlElementNames.GlobalLastDeliveryTime, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalLastDeliveryTime, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.Categories = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("Categories", XmlElementNames_1.XmlElementNames.Categories, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.Categories, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.GlobalCategories = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalCategories", XmlElementNames_1.XmlElementNames.GlobalCategories, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalCategories, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList(); });
    ConversationSchema.FlagStatus = new GenericPropertyDefinition_1.GenericPropertyDefinition("FlagStatus", XmlElementNames_1.XmlElementNames.FlagStatus, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.FlagStatus, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalFlagStatus = new GenericPropertyDefinition_1.GenericPropertyDefinition("GlobalFlagStatus", XmlElementNames_1.XmlElementNames.GlobalFlagStatus, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalFlagStatus, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.HasAttachments = new BoolPropertyDefinition_1.BoolPropertyDefinition("HasAttachments", XmlElementNames_1.XmlElementNames.HasAttachments, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.HasAttachments, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalHasAttachments = new BoolPropertyDefinition_1.BoolPropertyDefinition("GlobalHasAttachments", XmlElementNames_1.XmlElementNames.GlobalHasAttachments, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalHasAttachments, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.MessageCount = new IntPropertyDefinition_1.IntPropertyDefinition("MessageCount", XmlElementNames_1.XmlElementNames.MessageCount, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.MessageCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalMessageCount = new IntPropertyDefinition_1.IntPropertyDefinition("GlobalMessageCount", XmlElementNames_1.XmlElementNames.GlobalMessageCount, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalMessageCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.UnreadCount = new IntPropertyDefinition_1.IntPropertyDefinition("UnreadCount", XmlElementNames_1.XmlElementNames.UnreadCount, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.UnreadCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalUnreadCount = new IntPropertyDefinition_1.IntPropertyDefinition("GlobalUnreadCount", XmlElementNames_1.XmlElementNames.GlobalUnreadCount, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalUnreadCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.Size = new IntPropertyDefinition_1.IntPropertyDefinition("Size", XmlElementNames_1.XmlElementNames.Size, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.Size, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalSize = new IntPropertyDefinition_1.IntPropertyDefinition("GlobalSize", XmlElementNames_1.XmlElementNames.GlobalSize, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalSize, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.ItemClasses = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ItemClasses", XmlElementNames_1.XmlElementNames.ItemClasses, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.ItemClasses, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList("ItemClass"); });
    ConversationSchema.GlobalItemClasses = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalItemClasses", XmlElementNames_1.XmlElementNames.GlobalItemClasses, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalItemClasses, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new StringList_1.StringList("ItemClass"); });
    ConversationSchema.Importance = new GenericPropertyDefinition_1.GenericPropertyDefinition("Importance", XmlElementNames_1.XmlElementNames.Importance, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.Importance, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalImportance = new GenericPropertyDefinition_1.GenericPropertyDefinition("GlobalImportance", XmlElementNames_1.XmlElementNames.GlobalImportance, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalImportance, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.ItemIds = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ItemIds", XmlElementNames_1.XmlElementNames.ItemIds, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.ItemIds, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ItemIdCollection_1.ItemIdCollection(); });
    ConversationSchema.GlobalItemIds = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("GlobalItemIds", XmlElementNames_1.XmlElementNames.GlobalItemIds, ExchangeVersion_1.ExchangeVersion.Exchange2010_SP1, FieldUris.GlobalItemIds, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ItemIdCollection_1.ItemIdCollection(); });
    ConversationSchema.LastModifiedTime = new DateTimePropertyDefinition_1.DateTimePropertyDefinition("LastModifiedTime", XmlElementNames_1.XmlElementNames.LastModifiedTime, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.LastModifiedTime, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.InstanceKey = new ByteArrayPropertyDefinition_1.ByteArrayPropertyDefinition("InstanceKey", XmlElementNames_1.XmlElementNames.InstanceKey, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.InstanceKey, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.Preview = new StringPropertyDefinition_1.StringPropertyDefinition("Preview", XmlElementNames_1.XmlElementNames.Preview, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.Preview, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.IconIndex = new GenericPropertyDefinition_1.GenericPropertyDefinition("IconIndex", XmlElementNames_1.XmlElementNames.IconIndex, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.IconIndex, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalIconIndex = new GenericPropertyDefinition_1.GenericPropertyDefinition("GlobalIconIndex", XmlElementNames_1.XmlElementNames.GlobalIconIndex, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.GlobalIconIndex, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.DraftItemIds = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("DraftItemIds", XmlElementNames_1.XmlElementNames.DraftItemIds, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.DraftItemIds, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ItemIdCollection_1.ItemIdCollection(); });
    ConversationSchema.HasIrm = new BoolPropertyDefinition_1.BoolPropertyDefinition("HasIrm", XmlElementNames_1.XmlElementNames.HasIrm, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.HasIrm, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.GlobalHasIrm = new BoolPropertyDefinition_1.BoolPropertyDefinition("GlobalHasIrm", XmlElementNames_1.XmlElementNames.GlobalHasIrm, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.GlobalHasIrm, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    ConversationSchema.Instance = new ConversationSchema();
    return ConversationSchema;
})(ServiceObjectSchema_1.ServiceObjectSchema);
exports.ConversationSchema = ConversationSchema;
