var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var XmlElementNames_1 = require("../../XmlElementNames");
var PolicyTag_1 = require("../../../ComplexProperties/PolicyTag");
var ArchiveTag_1 = require("../../../ComplexProperties/ArchiveTag");
var ManagedFolderInformation_1 = require("../../../ComplexProperties/ManagedFolderInformation");
var PermissionSetPropertyDefinition_1 = require("../../../PropertyDefinitions/PermissionSetPropertyDefinition");
var ExchangeVersion_1 = require("../../../Enumerations/ExchangeVersion");
var StringPropertyDefinition_1 = require("../../../PropertyDefinitions/StringPropertyDefinition");
var IntPropertyDefinition_1 = require("../../../PropertyDefinitions/IntPropertyDefinition");
var EffectiveRightsPropertyDefinition_1 = require("../../../PropertyDefinitions/EffectiveRightsPropertyDefinition");
var GenericPropertyDefinition_1 = require("../../../PropertyDefinitions/GenericPropertyDefinition");
var PropertyDefinitionFlags_1 = require("../../../Enumerations/PropertyDefinitionFlags");
var ComplexPropertyDefinition_1 = require("../../../PropertyDefinitions/ComplexPropertyDefinition");
var FolderId_1 = require("../../../ComplexProperties/FolderId");
var ServiceObjectSchema_1 = require("./ServiceObjectSchema");
//module Microsoft.Exchange.WebServices.Data.FolderSchema {
var FieldUris;
(function (FieldUris) {
    FieldUris.FolderId = "folder:FolderId";
    FieldUris.ParentFolderId = "folder:ParentFolderId";
    FieldUris.DisplayName = "folder:DisplayName";
    FieldUris.UnreadCount = "folder:UnreadCount";
    FieldUris.TotalCount = "folder:TotalCount";
    FieldUris.ChildFolderCount = "folder:ChildFolderCount";
    FieldUris.FolderClass = "folder:FolderClass";
    FieldUris.ManagedFolderInformation = "folder:ManagedFolderInformation";
    FieldUris.EffectiveRights = "folder:EffectiveRights";
    FieldUris.PermissionSet = "folder:PermissionSet";
    FieldUris.PolicyTag = "folder:PolicyTag";
    FieldUris.ArchiveTag = "folder:ArchiveTag";
    FieldUris.DistinguishedFolderId = "folder:DistinguishedFolderId";
})(FieldUris || (FieldUris = {}));
//}
var FolderSchema = (function (_super) {
    __extends(FolderSchema, _super);
    function FolderSchema() {
        _super.apply(this, arguments);
    }
    FolderSchema.prototype.RegisterProperties = function () {
        _super.prototype.RegisterProperties.call(this);
        this.RegisterProperty(FolderSchema.Id);
        this.RegisterProperty(FolderSchema.ParentFolderId);
        this.RegisterProperty(FolderSchema.FolderClass);
        this.RegisterProperty(FolderSchema.DisplayName);
        this.RegisterProperty(FolderSchema.TotalCount);
        this.RegisterProperty(FolderSchema.ChildFolderCount);
        this.RegisterProperty(ServiceObjectSchema_1.ServiceObjectSchema.ExtendedProperties);
        this.RegisterProperty(FolderSchema.ManagedFolderInformation);
        this.RegisterProperty(FolderSchema.EffectiveRights);
        this.RegisterProperty(FolderSchema.Permissions);
        this.RegisterProperty(FolderSchema.UnreadCount);
        this.RegisterProperty(FolderSchema.WellKnownFolderName);
        this.RegisterProperty(FolderSchema.PolicyTag);
        this.RegisterProperty(FolderSchema.ArchiveTag);
    };
    /* <summary>
    /// Field URIs for folders.
    /// </summary>*/
    FolderSchema.Id = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("Id", XmlElementNames_1.XmlElementNames.FolderId, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.FolderId, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new FolderId_1.FolderId(); });
    FolderSchema.FolderClass = new StringPropertyDefinition_1.StringPropertyDefinition("FolderClass", XmlElementNames_1.XmlElementNames.FolderClass, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.FolderClass, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.ParentFolderId = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ParentFolderId", XmlElementNames_1.XmlElementNames.ParentFolderId, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.ParentFolderId, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new FolderId_1.FolderId(); });
    FolderSchema.ChildFolderCount = new IntPropertyDefinition_1.IntPropertyDefinition("ChildFolderCount", XmlElementNames_1.XmlElementNames.ChildFolderCount, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.ChildFolderCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.DisplayName = new StringPropertyDefinition_1.StringPropertyDefinition("DisplayName", XmlElementNames_1.XmlElementNames.DisplayName, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.DisplayName, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.UnreadCount = new IntPropertyDefinition_1.IntPropertyDefinition("UnreadCount", XmlElementNames_1.XmlElementNames.UnreadCount, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.UnreadCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.TotalCount = new IntPropertyDefinition_1.IntPropertyDefinition("TotalCount", XmlElementNames_1.XmlElementNames.TotalCount, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.TotalCount, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.ManagedFolderInformation = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ManagedFolderInformation", XmlElementNames_1.XmlElementNames.ManagedFolderInformation, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.ManagedFolderInformation, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ManagedFolderInformation_1.ManagedFolderInformation(); });
    FolderSchema.EffectiveRights = new EffectiveRightsPropertyDefinition_1.EffectiveRightsPropertyDefinition("EffectiveRights", XmlElementNames_1.XmlElementNames.EffectiveRights, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.EffectiveRights, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.Permissions = new PermissionSetPropertyDefinition_1.PermissionSetPropertyDefinition("Permissions", XmlElementNames_1.XmlElementNames.PermissionSet, ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1, FieldUris.PermissionSet, PropertyDefinitionFlags_1.PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags_1.PropertyDefinitionFlags.MustBeExplicitlyLoaded);
    FolderSchema.WellKnownFolderName = new GenericPropertyDefinition_1.GenericPropertyDefinition("WellKnownFolderName", XmlElementNames_1.XmlElementNames.DistinguishedFolderId, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.DistinguishedFolderId, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind);
    FolderSchema.PolicyTag = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("PolicyTag", XmlElementNames_1.XmlElementNames.PolicyTag, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.PolicyTag, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new PolicyTag_1.PolicyTag(); });
    FolderSchema.ArchiveTag = new ComplexPropertyDefinition_1.ComplexPropertyDefinition("ArchiveTag", XmlElementNames_1.XmlElementNames.ArchiveTag, ExchangeVersion_1.ExchangeVersion.Exchange2013, FieldUris.ArchiveTag, PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags_1.PropertyDefinitionFlags.CanFind, function () { return new ArchiveTag_1.ArchiveTag(); });
    FolderSchema.Instance = new FolderSchema();
    return FolderSchema;
})(ServiceObjectSchema_1.ServiceObjectSchema);
exports.FolderSchema = FolderSchema;
