var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var EwsLogging_1 = require("../Core/EwsLogging");
var ComplexPropertyDefinitionBase_1 = require("./ComplexPropertyDefinitionBase");
var ComplexPropertyDefinition = (function (_super) {
    __extends(ComplexPropertyDefinition, _super);
    function ComplexPropertyDefinition(propertyName, xmlElementName, version, uri, flags, propertyCreationDelegate) {
        _super.call(this, propertyName, xmlElementName, version, uri, flags);
        EwsLogging_1.EwsLogging.Assert(propertyCreationDelegate != null, "ComplexPropertyDefinition ctor", "CreateComplexPropertyDelegate cannot be null");
        this.propertyCreationDelegate = propertyCreationDelegate;
    }
    ComplexPropertyDefinition.prototype.CreatePropertyInstance = function (owner) {
        var complexProperty = this.propertyCreationDelegate();
        //info: Implementation check is implemented in complexproperty by using ___ImplementsInterface array property
        var isIOwnedProperty = complexProperty["___implementsInterface"].indexOf("IOwnedProperty") >= 0;
        if (isIOwnedProperty) {
            var ownedProperty = complexProperty;
            ownedProperty.Owner = owner;
        }
        if (complexProperty)
            return complexProperty;
    };
    return ComplexPropertyDefinition;
})(ComplexPropertyDefinitionBase_1.ComplexPropertyDefinitionBase);
exports.ComplexPropertyDefinition = ComplexPropertyDefinition;
