var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var EffectiveRights_1 = require("../Enumerations/EffectiveRights");
var XmlElementNames_1 = require("../Core/XmlElementNames");
var ExtensionMethods_1 = require("../ExtensionMethods");
var PropertyDefinition_1 = require("./PropertyDefinition");
var EffectiveRightsPropertyDefinition = (function (_super) {
    __extends(EffectiveRightsPropertyDefinition, _super);
    function EffectiveRightsPropertyDefinition() {
        _super.apply(this, arguments);
    }
    EffectiveRightsPropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) { throw new Error("EffectiveRightsPropertyDefinition.ts - LoadPropertyValueFromJson : Not implemented."); };
    EffectiveRightsPropertyDefinition.prototype.LoadPropertyValueFromXmlJsObject = function (jsObject, service, propertyBag) {
        var effectiveRightsValue = EffectiveRights_1.EffectiveRights.None;
        if (jsObject != null) {
            for (var key in jsObject) {
                switch (key) {
                    case XmlElementNames_1.XmlElementNames.CreateAssociated:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.CreateAssociated;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.CreateContents:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.CreateContents;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.CreateHierarchy:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.CreateHierarchy;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.Delete:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.Delete;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.Modify:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.Modify;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.Read:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.Read;
                        }
                        break;
                    case XmlElementNames_1.XmlElementNames.ViewPrivateItems:
                        if (ExtensionMethods_1.Convert.toBool(jsObject[key])) {
                            effectiveRightsValue |= EffectiveRights_1.EffectiveRights.ViewPrivateItems;
                        }
                        break;
                }
            }
        }
        propertyBag._setItem(this, jsObject);
        //throw new Error("EffectiveRightsPropertyDefinition.ts - LoadPropertyValueFromXmlJsObject : Not implemented.");
    };
    //WriteJsonValue(jsObject: JsonObject, propertyBag: PropertyBag, service: ExchangeService, isUpdateOperation: boolean): any { throw new Error("EffectiveRightsPropertyDefinition.ts - WriteJsonValue : Not implemented."); }
    EffectiveRightsPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        // EffectiveRights is a read-only property, no need to implement this.
        //throw new Error("EffectiveRightsPropertyDefinition.ts - WritePropertyValueToXml : Not implemented."); 
    };
    return EffectiveRightsPropertyDefinition;
})(PropertyDefinition_1.PropertyDefinition);
exports.EffectiveRightsPropertyDefinition = EffectiveRightsPropertyDefinition;
